INSERT INTO caption_types (id, description) VALUES
    (0, 'fully_automatic'),
    (1, 'partially_human'),
    (2, 'fully_human');

INSERT into file_formats (name, description, type) VALUES
     ('mp4', 'MP4 video file', 'video'), 
     ('ogv', 'OGG video file', 'video'), 
     ('wmv', 'WMV video file', 'video'), 
     ('avi', 'AVI video file', 'video'), 
     ('flv', 'FLV video file', 'video'), 
     ('m4v', 'M4V video file', 'video'), 
     ('webm', 'WEBM video file', 'video'), 
     ('mov', 'MOV video file', 'video'), 
     ('mpg', 'MPG video file', 'video'), 
     ('3gp', '3GP video file', 'video'), 
     ('mkv', 'MKV video file', 'video'), 
     ('wav', 'WAV audio file', 'audio'), 
     ('mp2', 'MP2 audio file', 'audio'), 
     ('mp3', 'MP3 audio file', 'audio'), 
     ('m4a', 'M4A audio file', 'audio'), 
     ('aac', 'AAC audio file', 'audio'), 
     ('flac', 'FLAC audio file', 'audio'), 
     ('ape', 'APE audio file', 'audio'), 
     ('wma', 'WMA audio file', 'audio'), 
     ('oga', 'OGG audio file', 'audio'),
     ('pcm', 'PCM stream file', 'audio'),
     ('dfxp', 'DFXP caption file', 'text'), 
     ('trs', 'TRS caption file', 'text'), 
     ('srt', 'SRT caption file', 'text'), 
     ('ppt', 'Powerpoint file', 'text'), 
     ('pptx', 'Powerpoint file', 'text'), 
     ('pptm', 'Powerpoint file', 'text'), 
     ('doc', 'Word file', 'text'), 
     ('docx', 'Word file', 'text'), 
     ('xls', 'Excel file', 'text'), 
     ('xlsx', 'Excel file', 'text'), 
     ('pdf', 'PDF file', 'text'), 
     ('xml', 'XML file', 'text'), 
     ('html', 'HTML file', 'text'), 
     ('txt', 'Plain text file', 'text'), 
     ('jpg', 'JPG image file', 'image'), 
     ('png', 'PNG image file', 'image'), 
     ('gif', 'GIF image file', 'image'), 
     ('bmp', 'BMP image file', 'image'),
     ('pbm', 'PBM image file', 'image'),
     ('pgm', 'PGM image file', 'image'),
     ('ppm', 'PPM image file', 'image'),
     ('tiff', 'TIFF image file', 'image'),
     ('zip', 'ZIP Package', 'package');

INSERT INTO file_types (id, name, description) VALUES
    (0, 'media', 'Main media file (video or audio)'),
    (1, 'slides', 'Slides file (video, ppt, pdf, txt)'),
    (2, 'docs', 'Related documents (ppt, pdf, txt)'),
    (3, 'thumbnail', 'Small video thumbnail'),
    (4, 'captions', 'Captions file (dfxp, trs, srt)'),
    (5, 'audiotrack', 'Synthetised audio tracks (TTS)'),
    (6, 'waveform', 'PCM stream used to draw waveforms'),
    (100, 'ori_document', 'original document file'),
    (101, 'parsed_document', 'parsed document file'),
    (102, 'translation', 'translation file');

INSERT INTO languages (code, name) VALUES
    ('es', 'Español'),
    ('en', 'English'),
    ('ca', 'Català'),
    ('gl', 'Galego'),
    ('eu', 'Euskera'),
    ('fr', 'Français'),
    ('it', 'Italiano'),
    ('sl', 'Slovenščina'),
    ('de', 'Deutsch'),
    ('pt', 'Português'),
    ('da', 'Danish'),
    ('cs', 'Czech'),
    ('af', 'Afrikaans'),
    ('no', 'Norwegian'),
    ('hu', 'Hungarian'),
    ('nl', 'Dutch'),
    ('sv', 'Swedish'),
    ('uk', 'Ukrainian'),
    ('sr', 'Serbian'),
    ('sq', 'Albanian'),
    ('sk', 'Slovak'),
    ('ru', 'Russian'),
    ('pl', 'Polish'),
    ('mk', 'Macedonian'),
    ('lv', 'Latvian'),
    ('lt', 'Lithuanian'),
    ('is', 'Icelandic'),
    ('hy', 'Armenian'),
    ('hr', 'Croatian'),
    ('ga', 'Irish'),
    ('el', 'Greek'),
    ('bs', 'Bosnian'),
    ('bg', 'Bulgarian'),
    ('tr', 'Turkish'),
    ('ja', 'Japanese'),
    ('ko', 'Korean'),
    ('zh', 'Chinese'),
    ('ar', 'Arabic');

INSERT INTO object_types (id, table_name) VALUES
    (0, 'videos'),
    (1, 'captions'),
    (2, 'audiotracks'),
    (100, 'documents'),
    (101, 'translations');

INSERT INTO users (id, username, name, email, password, admin, register_date, activated) VALUES
    (0, 'admin', 'Admin', 'admin@tlp.eu', 'd41d8cd98f00b204e9800998ecf8427e', True, '2015-01-01', True);

INSERT INTO users_quota (user_id) VALUES (0);
