jQuery(document).ready(function() {
  var ustats = {};
  var verbose = false;
  ustats["tldata"] = request_data;
  ustats["tldata"]["tlp-version"] = "TLP-3.0";
  ustats["global"] = {};
  ustats["global"]["time"] = new Date().getTime();
  ustats["global"]["htmltags_click"] = 0;
  ustats["active"] = {};
  ustats["active"]["last_init"] = new Date().getTime();
  ustats["active"]["last_event"] = "active";
  ustats["active"]["time"] = 0;
  ustats["segment"] = {};

  function reset_stats() {
    ustats = {};
    ustats["tldata"] = request_data;
    ustats["tldata"]["tlp-version"] = "TLP-3.0";
    ustats["global"] = {};
    ustats["global"]["time"] = new Date().getTime();
    ustats["global"]["htmltags_click"] = 0;
    ustats["active"] = {};
    ustats["active"]["last_init"] = new Date().getTime();
    ustats["active"]["last_event"] = "active";
    ustats["active"]["time"] = 0;
    ustats["segment"] = {};
  }

  function stats_active() {
    if (ustats["active"]["last_event"] != "active") {
      ustats["active"]["last_event"] = "active"; 
      ustats["active"]["last_init"] = new Date().getTime();
      if (verbose) console.log("[STATS] Active (counting)");
    }
  }

  function stats_disable() {
    if (ustats["active"]["last_event"] != "disable") {
      ustats["active"]["last_event"] = "disable"; 
      ustats["active"]["time"] += ((new Date().getTime())-ustats["active"]["last_init"]) / 1000;
      if (verbose) console.log("[STATS] Disabled (standby)");
    }
  }

  jQuery(document).on("mouseenter",function(e) {
    stats_active();
  });

  jQuery(document).on("mouseleave",function(e) {
    stats_disable();
  });

  jQuery('#options_show-html-button').click(function() {
    ustats["global"]["htmltags_click"]++;
  });

  var editElement = null;

  jQuery("#tlftable").on("click", "tbody tr td:nth-child(3) .list-group .list-group-item", function(e) {
    editElement = this;
    var sindex = jQuery(this).parent().parent().parent().index();
    if (verbose) console.log("[STATS] Segment #"+sindex+" clicked for editing");
    if (!(sindex in ustats["segment"])) {
      ustats["segment"][sindex] = {};
      ustats["segment"][sindex]["click"] = 0;
      ustats["segment"][sindex]["keypress"] = 0;
      ustats["segment"][sindex]["confirm"] = 0;
      ustats["segment"][sindex]["time"] = 0;
      ustats["segment"][sindex]["srctext"] = remove_html_tags(jQuery(this).parent().parent().parent().children('td:nth-child(2)').find('.list-group-item').text());
      ustats["segment"][sindex]["itext"] = remove_html_tags(jQuery(this).text());
    }
    ustats["segment"][sindex]["init_time"] = new Date().getTime();
    ustats["segment"][sindex]["click"]++;
  });

  jQuery("#tlftable").on("click", "span.confirm", function(e) {
    var sindex = jQuery(this).parent().parent().parent().index();
    if (verbose) console.log("[STATS] Confirm button clicked (segment #"+sindex+")");
    if (!(sindex in ustats["segment"])) {
      ustats["segment"][sindex] = {};
      ustats["segment"][sindex]["click"] = 0;
      ustats["segment"][sindex]["keypress"] = 0;
      ustats["segment"][sindex]["confirm"] = 0;
      ustats["segment"][sindex]["time"] = 0;
      ustats["segment"][sindex]["init_time"] = 0;
      ustats["segment"][sindex]["srctext"] = remove_html_tags(jQuery(this).parent().parent().parent().children('td:nth-child(2)').find('.list-group-item').text());
      ustats["segment"][sindex]["itext"] = remove_html_tags(jQuery(this).parent().children('.list-group-item').text());
    }
    ustats["segment"][sindex]["confirm"]++;
    ustats["segment"][sindex]["ftext"] = remove_html_tags(jQuery(this).parent().children('.list-group-item').text());
    if (ustats["segment"][sindex]["init_time"] != 0) ustats["segment"][sindex]["time"] += ((new Date().getTime())-ustats["segment"][sindex]["init_time"]) / 1000;
  });

  jQuery("#tlftable").on("blur", "tbody tr td:nth-child(3) .list-group .list-group-item", function(e) {
    if (this == editElement) {
      var sindex = jQuery(this).parent().parent().parent().index();
      ustats["segment"][sindex]["confirm"]++;
      ustats["segment"][sindex]["time"] += ((new Date().getTime())-ustats["segment"][sindex]["init_time"]) / 1000;
      // Discard if segment edit time > 5 min
      if (ustats["segment"][sindex]["time"] > 300) ustats["segment"][sindex]["time"] = 0;
      ustats["segment"][sindex]["ftext"] = remove_html_tags(jQuery(this).text());
      if (verbose) console.log("[STATS] Segment #"+sindex+" confirmed (time spent = "+ustats["segment"][sindex]["time"]+"s)");
      editElement = null;
    }
  });

  jQuery("#tlftable").on("keypress", "tbody tr td", function(e) {
    if (editElement != null) {
      var sindex = jQuery(editElement).parent().parent().parent().index();
      ustats["segment"][sindex]["keypress"]++;
    }
  });

  jQuery(document).on("doc:loaded", function(e) {
    if (verbose) console.log("[STATS] Loaded new translation ("+e.lang+"), resetting stats...");
    reset_stats();
    ustats["tldata"]["tlang"] = e.lang;
  });

  jQuery("#save-button").click(function() {
    stats_disable();
    ustats["global"]["time"] = ((new Date().getTime())-ustats["global"]["time"]) / 1000;
    ustats["global"]["total_segments"] = jQuery('#tlftable tbody tr').length;
    ustats["tldata"]["slang"] = langs["document_lang"];
    ustats["tldata"]["tlang"] = current_lang;
    jQuery.post("ttp-docedit/lib/stats.php", ustats).done(function() {
      reset_stats();
      if (verbose) console.log("[STATS] Stats file successfully saved");
    });
  });
});
