function print_document(doc_data, container) {
  jQuery(container).html(strip_scripts(doc_data["data"]));
}

function print_dtlx(dtlx_data) {
  if ("sL" in dtlx_data) jQuery('#tlftable thead tr th:nth-child(2)').html("Original <span class=\"text-muted\">("+dtlx_data["sL"]+")</span>");
  if ("tL" in dtlx_data) jQuery('#tlftable thead tr th:nth-child(3)').html("Translation <span class=\"text-muted\">("+dtlx_data["tL"]+")</span>");
  jQuery("#tlrtable tbody").empty();
  jQuery("#tlftable tbody").empty();
  var currentDtlxParentId = -1;
  var currentDtlxSegmentText = "";
  jQuery.each(dtlx_data["s"], function(index, value) {
    if ("or" in value && "tr" in value) {
      var rrow = "<tr id=\""+value["sI"]+"\""+("aT" in value && value["aT"] == "human" ? " class=\"edited\"" : "")+"><td>"+(index+1)+"</td><td><div class=\"list-group src\"><div class=\"list-group-item\">"+value["or"]+"</div><!--<span class=\"glyphicon glyphicon-arrow-right\" title=\"Copy original into translation\"></span>--></div></td><td><div class=\"list-group trans\"><div class=\"list-group-item\"><span class=\"confirm glyphicon glyphicon-ok-sign\"></span>"+value["tr"]+"</div></div></td><td>";
      if ("aT" in value && value["aT"] == "human") rrow += "<span class=\"glyphicon glyphicon-ok\" style=\"color: #008800;\"></span>";
      else rrow += "<span class=\"glyphicon glyphicon-cog\" style=\"color: #2f3033;\"></span>";
      rrow += "</td></tr>";
      jQuery("#tlrtable tbody").append(rrow);
    }
    if ("of" in value && "tf" in value) {
      var frow = "<tr id=\""+value["sI"]+"\""+("aT" in value && value["aT"] == "human" ? " class=\"edited\"" : "")+"><td>"+(index+1)+"</td><td><div class=\"list-group src\"><div class=\"list-group-item\">"+safe_tags_regex(value["of"])+"</div><!--<span class=\"glyphicon glyphicon-arrow-right\" title=\"Copy original into translation\"></span>--></div></td><td><div class=\"list-group trans\"><span class=\"confirm glyphicon glyphicon-thumbs-up\"></span><div class=\"list-group-item\">"+safe_tags_regex(value["tf"])+"</div></div></td><td>";
      if ("aT" in value && value["aT"] == "human") frow += "<span class=\"glyphicon glyphicon-ok\" style=\"color: #008800;\"></span>";
      else frow += "<span class=\"glyphicon glyphicon-cog\" style=\"color: #2f3033;\"></span>";
      frow += "</td></tr>";
      jQuery("#tlftable tbody").append(frow);
    }
    /* Update target HTML with DTLX changes */
    var dtlxId = value["sI"].split('->');
    if (dtlxId[0] != currentDtlxParentId) {
      jQuery('#thtmlcontent').find("[data-dtlx-id='"+currentDtlxParentId+"']").html(currentDtlxSegmentText);
      currentDtlxSegmentText = "";
    }
    currentDtlxSegmentText += value["tf"];
    currentDtlxParentId = dtlxId[0];
  });
  /* BUGFIX */
  jQuery('#tlftable .list-group-item').each(function() {
    jQuery(this).html(replaceHtmlEntites(jQuery(this).html()));
  });

  jQuery('#tlftable .list-group-item').each(function() {
    jQuery(this).html(safe_tags_regex(jQuery(this).html()));
  });
  /* END BUGFIX */
  onResize();
}

function onResize() {
  /*
  for (var i=0; i<jQuery("#tlftable tbody tr").length; i++) {
    jQuery("#tlftable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height("");
    jQuery("#tlftable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height("");
    if (jQuery("#tlftable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height() > jQuery("#tlftable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height()) jQuery("#tlftable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height(jQuery("#tlftable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height());
    else jQuery("#tlftable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height(jQuery("#tlftable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height());
  }
  for (var i=0; i<jQuery("#tlrtable tbody tr").length; i++) {
    jQuery("#tlrtable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height("");
    jQuery("#tlrtable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height("");
    if (jQuery("#tlrtable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height() > jQuery("#tlrtable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height()) jQuery("#tlrtable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height(jQuery("#tlrtable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height());
    else jQuery("#tlrtable tbody tr").eq(i).children("td").eq(1).find(".list-group-item").height(jQuery("#tlrtable tbody tr").eq(i).children("td").eq(2).find(".list-group-item").height());
  }
  */
}

var resizeTimeout = null;
jQuery(window).on("resize", function() {
  clearTimeout(resizeTimeout);
  resizeTimeout = setTimeout(function() {
      onResize();
    }, 250);
});

function fatal_error(message) {
  bootbox.hideAll();
  bootbox.alert(message, function() { history.go(-1); });
}

/* GLOBAL VARS */

var session_data = null;
var langs = {};
var metadata = {};
var current_lang = request_data["lang"];

/* API FUNCTIONS */

function text_metadata(callback) {
  var metadata_url = "lib/metadata.php?id="+request_data["id"];
  if ("hash" in request_data) metadata_url = metadata_url+"&hash="+request_data["hash"];
  if ("api_user" in request_data) metadata_url = metadata_url+"&user="+request_data["api_user"];
  if ("expire" in request_data) metadata_url = metadata_url+"&expire="+request_data["expire"];
  if ("request_key" in request_data) metadata_url = metadata_url+"&auth_token="+request_data["request_key"];
  jQuery.ajax({
    url: metadata_url,
    dataType: "json",
    cache: false,
    success: function(data) {
      if (data != null && "rcode" in data && data["rcode"] == 0) {
        metadata = data;
        callback();
      }
      else fatal_error("Cannot retrieve document metadata from Web Service for document ID '"+request_data["id"]+"'");
    },
    error: function() {
      fatal_error("Cannot retrieve document metadata from Web Service for document ID '"+request_data["id"]+"'");
    }
  });
}

function text_langs(callback) {
  var langs_url = "lib/langs.php?id="+request_data["id"];
  if ("hash" in request_data) langs_url = langs_url+"&hash="+request_data["hash"];
  if ("api_user" in request_data) langs_url = langs_url+"&user="+request_data["api_user"];
  if ("expire" in request_data) langs_url = langs_url+"&expire="+request_data["expire"];
  if ("request_key" in request_data) langs_url = langs_url+"&auth_token="+request_data["request_key"];
  jQuery.ajax({
    url: langs_url,
    dataType: "json",
    cache: false,
    success: function(data) {
      if (data != null && "rcode" in data && data["rcode"] == 0) {
        langs = data;
        callback();
      }
      else fatal_error("Cannot retrieve available translations from Web Service for document ID '"+request_data["id"]+"'");
    },
    error: function() {
      fatal_error("Cannot retrieve available translations from Web Service for document ID '"+request_data["id"]+"'");
    }
  });
}

function text_get(lang, format, callback, session_id) {
  var get_url = "lib/get.php?id="+request_data["id"]+"&lang="+lang+"&format="+format;
  if ("hash" in request_data) get_url = get_url+"&hash="+request_data["hash"];
  if ("api_user" in request_data) get_url = get_url+"&user="+request_data["api_user"];
  if ("expire" in request_data) get_url = get_url+"&expire="+request_data["expire"];
  if ("request_key" in request_data) get_url = get_url+"&auth_token="+request_data["request_key"];
  if (typeof session_id !== 'undefined' && session_id != 'ingest_service') get_url = get_url+"&session_id="+session_id;
  else if (typeof session_id !== 'undefined' && session_id == 'ingest_service') get_url = get_url+"&sel_data_policy=1";
  jQuery.ajax({
    url: get_url,
    dataType: "json",
    cache: false,
    success: function(data) {
      if (data != null && "rcode" in data && data["rcode"] == 0) callback(data);
      else {
        bootbox.hideAll();
        if (data != null && "rcode_description" in data) fatal_error("Error retrieving the translation file from Web Service: "+data["rcode_description"]);
        else fatal_error("Error retrieving the translation file from Web Service.");
      }
    },
    error: function() {
      fatal_error("Error retrieving the translation file from Web Service for document ID '"+request_data["id"]+"'");
    }
  });
}

function text_mod() {
  var modjson = { "data": {"id": request_data["id"], "lang": current_lang, "session_id": session_data["session_id"], "author_id": request_data["author_id"], "author_conf": request_data["author_conf"], "user": request_data["api_user"], "auth_token": request_data["request_key"], "expire": request_data["expire"], "mods" : { }}};
  modjson["data"]["mods"][current_lang] = {"txt" : []};
  jQuery("#tlftable tbody tr").each(function() {
    if (jQuery(this).hasClass("edited")) {
      //var ortext = replaceHtmlEntites(jQuery(this).children("td:nth-child(2)").children(".list-group").children(".list-group-item").html());
      //ortext = jQuery("<p>"+ortext+"</p>").text();
      //var oftext = replaceHtmlEntites(jQuery(this).children("td:nth-child(2)").children(".list-group").children(".list-group-item").html());
      var trtext = replaceHtmlEntites(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
      trtext = jQuery("<p>"+trtext+"</p>").text();
      var tftext = replaceHtmlEntites(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
      //modjson["data"]["mods"][current_lang]["txt"].push({"sI" : jQuery(this).attr("id"), "t" : {"t" : {"r" : trtext, "f" : tftext }, "o": {"r" : ortext, "f" : oftext }}});
      modjson["data"]["mods"][current_lang]["txt"].push({"sI" : parseInt(jQuery(this).attr("id")), "t" : tftext });
    }
  });
  if (modjson["data"]["mods"][current_lang]["txt"].length > 0) {
    jQuery.ajax({
      type: "POST",
      url: "lib/mod.php",
      data: modjson,
      success: function(response) {
        if (("rcode" in response) && response["rcode"] == 0) bootbox.alert("The translation changes have been successfully saved.");
        else {
          if ("rcode_description" in response) bootbox.alert("Error saving translation changes: "+response["rcode_description"]);
          else bootbox.alert("Error saving translation changes: there was an error while contacting the Web Service.");
        }
      },
      error: function() {
        bootbox.alert("Error saving translation changes: there was an error while contacting the Web Service.");
      },
      dataType: "json"
    });
  }
  else bootbox.alert("There are no changes to save.");
}

function text_start_session(callback) {
  var start_session_url = "lib/start_mod_session.php?id="+request_data["id"];
  if ("hash" in request_data) start_session_url = start_session_url+"&hash="+request_data["hash"];
  if ("author_id" in request_data) start_session_url = start_session_url+"&author_id="+request_data["author_id"];
  if ("author_name" in request_data) start_session_url = start_session_url+"&author_name="+request_data["author_name"];
  if ("author_conf" in request_data) start_session_url = start_session_url+"&author_conf="+request_data["author_conf"];
  if ("api_user" in request_data) start_session_url = start_session_url+"&user="+request_data["api_user"];
  if ("expire" in request_data) start_session_url = start_session_url+"&expire="+request_data["expire"];
  if ("request_key" in request_data) start_session_url = start_session_url+"&auth_token="+request_data["request_key"];
  jQuery.ajax({
    url: start_session_url,
    dataType: "json",
    cache: false,
    success: function(data) {
      session_data = data;
      callback();
    },
    error: function() {
      fatal_error("Error: unable to start an editing session (error contacting Web Service)");
    }
  });
}

function text_session_status(alive) {
  if (session_data != null) {
    var session_status_url = "lib/session_status.php?id="+request_data["id"]+"&author_id="+request_data["author_id"]+"&author_conf="+request_data["author_conf"]+"&session_id="+session_data["session_id"];
    if (typeof alive !== 'undefined') session_status_url = session_status_url+"&alive="+(alive ? "1" : "0");
    if ("hash" in request_data) session_status_url = session_status_url+"&hash="+request_data["hash"];
    if ("api_user" in request_data) session_status_url = session_status_url+"&user="+request_data["api_user"];
    if ("expire" in request_data) session_status_url = session_status_url+"&expire="+request_data["expire"];
    if ("request_key" in request_data) session_status_url = session_status_url+"&auth_token="+request_data["request_key"];
    jQuery.ajax({
      url: session_status_url,
      dataType: "json",
      cache: false,
      success: function(data) {
        if (data != false && "rcode" in data) {
          if (data["rcode"] != 0) {
            session_data = null;
            var msg = "";
            if (data["rcode"] == 4 && "ended_by_id" in data && data["ended_by_id"] != null) {
              msg = "Your session has been closed by <strong>"+(data["ended_by_name"] != null ? data["ended_by_name"] : data["ended_by_id"])+"</strong>. ";
            }
            else msg = "Your session has expired. ";
            bootbox.confirm(msg+"Do you want to try re-opening the session?", function(resp) {
              if (resp) {
                text_start_session(function() {
                  if (session_data["rcode"] != 0) {
                    jQuery('#save-button').hide();
                    bootbox.alert(session_data["rcode_description"]+"<br/>You will not be able to save any changes, but you can still download the translation with your changes.", function() { load_status++; });
                  }
                });
              }
              else {
                bootbox.alert("You will not be able to save any changes, but you can still download the translation with your changes.");
                jQuery('#save-button').hide();
              }
            });
          }
        }
        else {
          console.log("ERROR: Could not retrieve nor update session status. Web Service unavailable?");
        }
      },
      error: function() {
        console.log("ERROR: Could not retrieve nor update session status (/lib/session_status.php failure?)");
      }
    });
  }
}

function text_end_session(callback) {
  if (session_data != null) {
    var start_session_url = "lib/end_mod_session.php?id="+request_data["id"]+"&session_id="+session_data["session_id"];
    if ("hash" in request_data) start_session_url = start_session_url+"&hash="+request_data["hash"];
    if ("author_id" in request_data) start_session_url = start_session_url+"&author_id="+request_data["author_id"];
    if ("author_name" in request_data) start_session_url = start_session_url+"&author_name="+request_data["author_name"];
    if ("author_conf" in request_data) start_session_url = start_session_url+"&author_conf="+request_data["author_conf"];
    if ("api_user" in request_data) start_session_url = start_session_url+"&user="+request_data["api_user"];
    if ("expire" in request_data) start_session_url = start_session_url+"&expire="+request_data["expire"];
    if ("request_key" in request_data) start_session_url = start_session_url+"&auth_token="+request_data["request_key"];
    jQuery.ajax({
      url: start_session_url,
      dataType: "json",
      cache: false,
      success: function(data) {
        session_data = null;
        callback(data);
      },
      error: function() {
        fatal_error("Cannot retrieve available translations from Web Service for document ID '"+request_data["id"]+"'");
      }
    });
  }
}

function load_lang(lang) {
  var load_status = 0;
  editElement = null;
  bootbox.hideAll();
  bootbox.dialog({
    message: "Loading user revision, please wait...",
    closeButton: false,
    buttons: {}
  });
  current_lang = lang;
  text_get(langs["document_lang"], 1, function(response1) {
    print_document(response1, jQuery('#ohtmlcontent'));
    text_get(current_lang, 1, function(response2) {
      print_document(response2, jQuery('#thtmlcontent'));
      text_get(current_lang, 2, function(response3) {
        print_dtlx(response3);
        bootbox.hideAll();
        show_edit_history(true);
        /* throw load event */
        jQuery.event.trigger({
          type: "doc:loaded",
          lang: current_lang
        });
      });
    });
  });
}

function load_user_revision(session_id, callback) {
  editElement = null;
  bootbox.hideAll();
  bootbox.dialog({
    message: "Loading translations, please wait...",
    closeButton: false,
    buttons: {}
  });
  text_get(langs["document_lang"], 1, function(response1) {
    print_document(response1, jQuery('#ohtmlcontent'));
    text_get(current_lang, 1, function(response2) {
      print_document(response2, jQuery('#thtmlcontent'));
      text_get(current_lang, 2, function(response3) {
        print_dtlx(response3);
        bootbox.hideAll();
        /* throw load event */
        jQuery.event.trigger({
          type: "doc:loaded",
          lang: current_lang
        });
        if (typeof callback !== 'undefined') callback();
      }, session_id);
    }, session_id);
  }, session_id);
}

jQuery(document).ready(function() {

  /* MAIN THREAD, EXECUTE ON LOAD */

  bootbox.dialog({
    message: "Loading document metadata, please wait...",
    closeButton: false,
    buttons: {}
  });
  text_metadata(function() {
    text_start_session(function() {
      if (session_data["rcode"] != 0) {
        jQuery('#save-button').hide();
        bootbox.alert(session_data["rcode_description"]+"<br/>You will not be able to save any changes, but you can still download the translation with your changes.", function() { load_status++; });
      }
      text_langs(function() {
        jQuery.each(langs["langs"], function(index, val) {
          jQuery('#language-select').append('<option value="'+val["lang_code"]+'">'+val["lang_name"]+'</option>');
        });
        jQuery('#language-select').val(request_data["lang"]);
        jQuery('#language-select').on("change", function() {
          load_lang(jQuery(this).val());
        });
        load_user_revision(session_data["session_id"], function() { show_edit_history(true); });
      });
    });
  });

  /* EDITOR FUNCTIONALITY */

  var editElement = null;
  jQuery("#save-button").click(function() {
    text_mod();
  });

  jQuery('#download-button').on("click", "a", function() {
    alt_download(this, jQuery('#thtmlcontent').html());
  });
  
  jQuery('#navbar').on("click", "li", function() {
    if (typeof jQuery(this).attr('id') === 'undefined') {
      jQuery('#navbar li').removeClass("active");
      jQuery(this).addClass("active");
      if (jQuery(this).index() == 1) { // Editor
        jQuery('#viewer').hide();
        jQuery('#editor').show();
        //onResize();
      }
      else if (jQuery(this).index() == 2) { // HTML viewer (translation)
        jQuery('#editor').hide();
        jQuery('#ohtmlcontent').hide();
        jQuery('#thtmlcontent').show();
        jQuery('#viewer').show();
      }
      else if (jQuery(this).index() == 0) { // HTML viewer (original)
        jQuery('#editor').hide();
        jQuery('#thtmlcontent').hide();
        jQuery('#ohtmlcontent').show();
        jQuery('#viewer').show();
      }
    }
  });

  function show_edit_history(only_pending) {
    if (typeof only_pending === 'undefined') only_pending = false;
    var revurl = "lib/edit_history.php?id="+request_data["id"];
    if ("hash" in request_data) revurl = revurl+"&hash="+request_data["hash"];
    if ("api_user" in request_data) revurl = revurl+"&user="+request_data["api_user"];
    if ("request_key" in request_data) revurl = revurl+"&auth_token="+request_data["request_key"];
    if ("expire" in request_data) revurl = revurl+"&expire="+request_data["expire"];
    jQuery.ajax({
      url: revurl,
      dataType: "json",
      cache: false,
      async: true,
      success: function(rdata) {
        if (rdata != false && "rcode" in rdata && rdata["rcode"] == 0) {
          var dmsg = '';
          if (only_pending) dmsg += '<h5>There are some pending revisions for this translation:</h5>';
          dmsg += '<table class="table table-hover" style="font-size: 1em;"><tbody>';
          var pending_revisions = 0;
          for (var i=0; i<rdata["edit_history"].length; i++) {
            if (current_lang in rdata["edit_history"][i]["edit_stats"]) {
              if (!only_pending || (rdata["edit_history"][i]["requires_revision"] && rdata["edit_history"][i]["revised"] == false)) {
                dmsg += "<tr><td style=\"padding-left: 1em;\"><i class=\"fa fa-user\" style=\"color: #4BA6AF; margin-right: 0.5em;\"></i> <strong>"+(rdata["edit_history"][i]["author_name"] != null ? rdata["edit_history"][i]["author_name"] : rdata["edit_history"][i]["author_id"])+"</strong></td><td>"+rdata["edit_history"][i]["timestamp"].slice(0, -10)+"</td><td>"+(rdata["edit_history"][i]["revised"] == true ? "<i class=\"fa fa-check\" style=\"cursor: help; color: #4BA6AF; margin-top: 4px;\" title=\"Revised by "+(rdata["edit_history"][i]["revised_by_name"] != null ? rdata["edit_history"][i]["revised_by_name"] : rdata["edit_history"][i]["revised_by_id"])+" ("+rdata["edit_history"][i]["revised_at"].substring(0, rdata["edit_history"][i]["revised_at"].length-10)+")\"></i>" : "")+"</td><td><button class=\"btn btn-sm btn-default\" onclick=\"load_user_revision("+rdata["edit_history"][i]["session_id"]+"); return false;\">Load</button></td></tr>";
                pending_revisions++;
              }
            }
          }
          /* Ingest Service original translation */
          if (!only_pending) dmsg += "<tr><td style=\"padding-left: 1em;\"><i class=\"fa fa-cogs\" style=\"color: #4BA6AF; margin-right: 0.5em;\"></i> <strong>Ingest Service</strong></td><td>-</td><td></td><td><button class=\"btn btn-sm btn-default\" onclick=\"load_user_revision('ingest_service'); return false;\">Load</button></td></tr>";
          if (!only_pending || pending_revisions > 0) bootbox.dialog({
            title: "Revisions history ("+current_lang+")",
            message: dmsg,
            buttons: {
              ok: {
                label: "Close",
                className: "btn-primary"
              }
            }
          });
          jQuery('.modal-body').css('padding', '0');
        }
        else {
          if ("rcode_description" in rdata) bootbox.alert("Unable to retrieve edit history: "+rdata["rcode_description"]);
          bootbox.alert("Unable to retrieve edit history: call to /edit_history failed.");
        }
      },
      error: function() {
        bootbox.alert("Unable to retrieve edit history: call to lib/edit_history.php failed.");
      }
    });
  }

  jQuery('#options-button').click(function() {
    bootbox.dialog({
      title: "Options",
      message: '<div class="form-horizontal"><div class="form-group"><label class="col-md-8 control-label">Show HTML tags</label><div class="col-md-4"><button id="options_show-html-button" class="btn btn-default active" style="width: 100%">Enabled</button></div></div><div class="form-group"><label class="col-md-8 control-label">View user editing history</label><div class="col-md-4"><button id="options_show-edit-history" class="btn btn-default" style="width: 100%">Show</button></div></div></div>',
      buttons: {
        ok: {
          label: "Close",
          className: "btn-primary"
        }
      }
    });

    jQuery('#options_show-html-button').click(function() {
      if (jQuery(this).hasClass("active")) {
        jQuery(this).removeClass("active");
        jQuery(this).text("Disabled");
        jQuery('#tlftable .list-group-item').each(function() {
          jQuery(this).html(replaceHtmlEntites(jQuery(this).html()));
        });
        onResize();
      }
      else {
        jQuery(this).addClass("active");
        jQuery(this).text("Enabled");
        jQuery('#tlftable .list-group-item').each(function() {
          jQuery(this).html(safe_tags_regex(jQuery(this).html()));
        });
        onResize();
      }
    });
    jQuery('#options_show-edit-history').click(function() {
      bootbox.hideAll();
      show_edit_history();
    });
  });

  function merge(i) {
    jQuery("#tlftable tbody tr").each(function(index) {
      if (index == i) {
        jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html()+" "+jQuery("#tlftable tbody tr:nth-child("+(i+2)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
        jQuery(this).removeClass("edited").addClass("edited");
      }
      else if (index > i) {
        jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html(jQuery("#tlftable tbody tr:nth-child("+(index+2)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
        jQuery(this).removeClass("edited").addClass("edited");
      }
    });
  }

  function insert(i) {
    var oldText = "";
    var newText = "";
    jQuery("#tlftable tbody tr").each(function(index) {
      if (index > i) {
        oldText = jQuery("#tlftable tbody tr:nth-child("+(index+1)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html();
        if (index == jQuery("#tlftable tbody tr").length-1) jQuery("#tlftable tbody tr:nth-child("+(index+1)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html(newText+" "+jQuery("#tlftable tbody tr:nth-child("+(index+1)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
        else jQuery("#tlftable tbody tr:nth-child("+(index+1)+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").html(newText);
        newText = oldText;
        jQuery(this).removeClass("edited").addClass("edited");
      }
    });
  }

  function confirmSegment(e) {
    if (e != null) {
      jQuery('#save-button').prop("disabled", false);
      if (jQuery('#options_show-html-button').hasClass("active")) {
        jQuery(e).html(replaceHtmlEntites(jQuery(e).html()));
      }
      /* Update source and target HTML views */
      var dtlxid = jQuery(e).parent().parent().parent().attr("id").split("->");
      var stext = "";
      var ttext = "";
      if (jQuery("#tlftable tbody tr[id^='"+dtlxid[0]+"->']").length > 0) {
        jQuery("#tlftable tbody tr[id^='"+dtlxid[0]+"->']").each(function(i) {
          if (i > 0) {
            stext += " ";
            ttext += " ";
          }
          stext += replaceHtmlEntites(jQuery(this).children("td:nth-child(2)").children(".list-group").children(".list-group-item").html());
          ttext += replaceHtmlEntites(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
        });
      }
      else {
        jQuery("#tlftable tbody tr[id="+dtlxid[0]+"]").each(function(i) {
          if (i > 0) {
            stext += " ";
            ttext += " ";
          }
          stext += replaceHtmlEntites(jQuery(this).children("td:nth-child(2)").children(".list-group").children(".list-group-item").html());
          ttext += replaceHtmlEntites(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
        });
      }
      jQuery('#ohtmlcontent').find("[data-dtlx-id='"+dtlxid[0]+"']").html(stext);
      jQuery('#thtmlcontent').find("[data-dtlx-id='"+dtlxid[0]+"']").html(ttext);
      /*  */
      jQuery(e).parent().children("span.confirm").css("color", "#008800");
      jQuery(e).parent().parent().parent().css("background-color", "");
      jQuery(e).parent().parent().parent().addClass("edited");
      jQuery(e).parent().parent().parent().children("td").eq(3).children("span").removeClass("glyphicon-pencil glyphicon-cog glyphicon-ok").addClass("glyphicon-ok").css("color", "#008800").attr("title", "Manually translated");
    }
    text_session_status(true);
  }

  jQuery("#tlftable").on("click", "tbody tr td .list-group.trans .list-group-item", function(e) {
    editElement = this;
    jQuery(this).parent().parent().parent().children("td").eq(3).children("span").removeClass("glyphicon-cog glyphicon-ok").addClass("glyphicon-pencil").css("color", "#428bca").attr("title", "Translating...");
    jQuery(this).parent().parent().parent().css("background-color", "#EEE");
    jQuery(this).attr("contenteditable", "true");
    jQuery(this).trigger("focus");
  });

  jQuery("#tlftable").on("click", "span.glyphicon-arrow-right", function(e) {
    jQuery(this).parent().parent().parent().children("td").eq(2).find(".list-group-item").html(jQuery(this).parent().children(".list-group-item").html());
    confirmSegment(jQuery(this).parent().parent().parent().children("td").eq(2).find(".list-group-item"));
  });

  jQuery("#tlftable").on("click", "span.confirm", function(e) {
    confirmSegment(jQuery(this).parent().children(".list-group-item"));
  });

  jQuery("#tlftable").on("blur", "tbody tr td .list-group.trans .list-group-item", function() {
    if (this == editElement) {
      confirmSegment(editElement);
      editElement = null;
    }
  });

  jQuery("#tlftable").on("keydown", "tbody tr td", function(e) {
    if (e.ctrlKey && e.keyCode == 77) {
      //merge(jQuery(editElement).parent().parent().parent().index());
      return false;
    }
    if (e.ctrlKey && e.keyCode == 73) {
      //insert(jQuery(editElement).parent().parent().parent().index());
      return false;
    }
  });

  jQuery("#tlftable").on("keypress", "tbody tr td", function(e) {
    // resize on writing
    if (jQuery(this).children(".list-group").children(".list-group-item").height() > jQuery(this).parent().children("td").eq(1).children(".list-group").children(".list-group-item").height()) jQuery(this).parent().children("td").eq(1).children(".list-group").children(".list-group-item").height(jQuery(this).children(".list-group").children(".list-group-item").height());

    switch (e.keyCode) {
      case 13:
        confirmSegment(editElement);
        var nextSegmentIndex = (jQuery(editElement).parent().parent().parent().index())+2;
        editElement = null;
        // scrollTo
        var yoffset = (jQuery('#tlf .scrollable').scrollTop() + jQuery(jQuery(this).parent().parent().children("tr:nth-child("+nextSegmentIndex+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item")).parent().parent().parent().position().top - (jQuery('#tlf .scrollable').height()/1.5));
        jQuery('#tlf .scrollable').scrollTop(yoffset);
        jQuery(this).parent().parent().children("tr:nth-child("+nextSegmentIndex+")").children("td:nth-child(3)").children(".list-group").children(".list-group-item").trigger("click");
        return false;
    }
  });

  jQuery("#tlftable").on("paste", function(e) {
    e.preventDefault();
    var text = (e.originalEvent || e).clipboardData.getData("text/plain");
    document.execCommand("insertHTML", false, text);
  });
});

jQuery(window).on("beforeunload", function() {
  if (session_data != null && "rcode" in session_data && session_data["rcode"] == 0) text_end_session();
});

/* AUXILIAR FUNCTIONS */

function alt_download(link, text) {
  if (typeof metadata !== 'undefined' && "info" in metadata) {
    var blob = new Blob([text]);
    var url  = URL.createObjectURL(blob);
    link.download = request_data["id"]+"."+request_data["lang"]+"."+metadata["info"]["format"];
    link.href = url;
  }
  else {
    var blob = new Blob([text], {type: "text/html"});
    var url  = URL.createObjectURL(blob);
    link.download = request_data["id"]+"."+request_data["lang"]+".html";
    link.href = url;
  }
}

function download(filename, text) {
  var pom = document.createElement('a');
  pom.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
  pom.setAttribute('download', filename);
  pom.click();
}

function safe_tags_regex(str) {
  return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

function remove_html_tags(str) {
  var regex = /(<([^>]+)>)/ig;
  return str.replace(regex, "");
}

var replaceHtmlEntites = (function() {
  var translate_re = /&(nbsp|amp|quot|lt|gt);/g;
  var translate = {
    "nbsp": " ", 
    "amp" : "&", 
    "quot": "\"",
    "lt"  : "<", 
    "gt"  : ">"
  };
  return function(s) {
    return ( s.replace(translate_re, function(match, entity) { 
      return translate[entity]; 
    }) );
  }
})();

function strip_scripts(s) {
  var div = document.createElement('div');
  div.innerHTML = s;
  var scripts = div.getElementsByTagName('script');
  var i = scripts.length;
  while (i--) {
    scripts[i].parentNode.removeChild(scripts[i]);
  }
  return div.innerHTML;
}

jQuery(document).ready(function() {
  jQuery('#saveParallelText').click(function() {
    var parallelText = "";
    jQuery("#tlftable tbody tr").each(function() {
      srcText = replaceHtmlEntites(jQuery(this).children("td:nth-child(2)").children(".list-group").children(".list-group-item").html());
      tarText = replaceHtmlEntites(jQuery(this).children("td:nth-child(3)").children(".list-group").children(".list-group-item").html());
      parallelText += srcText + "\n" + tarText + "\n\n";
    });
    var blob = new Blob([parallelText], {type: "text/plain"});
    var url  = URL.createObjectURL(blob);
    this.download = request_data["id"]+"."+request_data["lang"]+".txt";
    this.href = url;
  });
});
