#!/usr/bin/python
import os
import json
import psycopg2
import sys
import libdtlx

docs_path = "/home/tluser/tldoc-repositories/tldoc2/trans/"
path = "../stats/"
users = ["kairit@tlu.ee", "unina", "francis.brouns@ou.nl", "jchao0", "admin"]
dstats = {} # array [doc_id, time]

conn = psycopg2.connect("dbname=tldoc2 user=tluser")
cur = conn.cursor()
cur.execute("SELECT documents.id, external_id, title, file_path, sentences FROM documents INNER JOIN translations ON translations.document_id = documents.id INNER JOIN files ON translations.id = files.object_id WHERE files.object_type_id = 1 AND files.file_format LIKE 'xml'")
docs_data = {}
for row in cur.fetchall():
  docs_data[row[1]] = [row[2], row[3], row[4]]

for u in users:
  dstats[u] = {}
  for i in os.listdir(path):
    if os.path.isfile(os.path.join(path,i)) and u in i:
      dinfo = i[len(u)+1:].split(".")
      did = dinfo[0]
      dpair = dinfo[1]
      json_data = open(os.path.join(path,i))
      data = json.load(json_data);
      if (dpair in dstats[u]):
        if (did in dstats[u][dpair] and "segment" in data):
          #dstats[u][dpair][did][0] = dstats[u][dpair][did][0]+float(data["active"]["time"])
          dstats[u][dpair][did][0] = dstats[u][dpair][did][0]+float(data["global"]["time"])
          dstats[u][dpair][did][1] = dstats[u][dpair][did][1]+len(data["segment"])
        elif ("segment" in data):
          #dstats[u][dpair][did] = [float(data["active"]["time"]), len(data["segment"]), 0, 0, 0]
          dstats[u][dpair][did] = [float(data["global"]["time"]), len(data["segment"]), 0, 0, 0]
      else:
        dstats[u][dpair] = {}
      json_data.close()

for u in dstats:
  for lpair in dstats[u]:
    print "User: "+u+" ("+lpair+")"
    utotalwords = 0
    utotalsecs = 0
    for did in dstats[u][lpair]:
      try:
        dtlx = libdtlx.Parser().parse(os.path.join(docs_path, docs_data[did][1]))
        dtlx.filter(3)
        dsents = 0
        dwords = 0
        dchars = 0
        for s in dtlx.sentences:
          dsents += 1
          dwords += len(s.origin.rawText.split())
          dchars += len(s.origin.rawText)
        dstats[u][lpair][did][2] = dsents
        dstats[u][lpair][did][3] = dwords
        dstats[u][lpair][did][4] = dchars
        rperc = float(dsents)/float(dstats[u][lpair][did][1])
        if (rperc > 1): 
          rperc = 1
        if (rperc == 1 and did != "aku"):
          utotalwords += dwords
          utotalsecs += dstats[u][lpair][did][0]
          #print "\tDocument ID: "+did
          #print "\tReviewed: "+str(rperc*100)+"%, Words-per-minute: "+str(dwords/(dstats[u][lpair][did][0]/60))
          #print "\tTotal time: "+str(dstats[u][lpair][did][0])+"s, Total words: "+str(dwords)
          #print ""
      except:
        continue
    print "Average Words-per-minute: "+str(utotalwords/(utotalsecs/60))
    print ""
