#!/usr/bin/python

from libdfxp import *
import sys

def processDfxp(pdfxp, translate):
  timeStamp = datetime.now()
  pdfxp.timeStamp = timeStamp
  for i in xrange(len(pdfxp.data)):
    d1 = pdfxp.data[i]
    if isinstance(d1,TlSegment):
      processTlSegment(d1, translate)
    elif isinstance(d1,TlAlt):
      processTlAlt(d1, translate)

def processTlSegment(s, translate):
  string = ""
  for d in s.data:
    if isinstance(d,TlWord) or isinstance(d,TlRawText):
      string += "%s "%(d.txt)
  string = translate(string,s)
  s.data = [TlRawText(string)]

def processTlAlt(a, translate):
  for d in a.data:
    if isinstance(d,TlSegment):
      processTlSegment(d, translate)

def translate(text,s):
  print "#-%d-# %s"%(int(s.segmentId),text.replace("[hesitation]","").replace("<unk>","").encode("UTF-8"))

if len(sys.argv) != 2:
  print "Usage: %s <dfxp>"%(sys.argv[0])
  sys.exit(1)

dfxp_fn = sys.argv[1]
pdfxp = parseDfxp(dfxp_fn)
pdfxp.data = filterDfxp(pdfxp)
processDfxp(pdfxp, translate)


