#!/usr/bin/python

import sys
from ConfigParser import ConfigParser

if len(sys.argv) != 3:
  sys.stderr.write('Usage: %s CONFIG_FILE "Section->Variable->Value; ... "\n' % sys.argv[0])
  sys.exit(1)

config_fp = sys.argv[1]
expr = sys.argv[2]

config = ConfigParser(allow_no_value=True)
with open(config_fp) as cfg_fd:
  config.readfp(cfg_fd)

for i in expr.split(";"):
  if len(i.strip()) > 0:
    section = i.split("->")[0].strip()
    variable = i.split("->")[1].strip()
    value = i.split("->")[2].strip()
    config.set(section, variable, value)

config.write(sys.stdout)
