#!/usr/bin/python

import sys
import json

if len(sys.argv) != 3:
  sys.stderr.write('Usage: %s JSON_FILE "Key->Value; ... "\n' % sys.argv[0])
  sys.exit(1)

json_fp = sys.argv[1]
expr = sys.argv[2]

D = {}
with open(json_fp) as json_fd:
  D = json.load(json_fd, encoding='UTF-8')

for i in expr.split(";"):
  if len(i.strip()) > 0:
    key = i.split("->")[0].strip()
    value = i.split("->")[1].strip()
    D[key] = value

jstr = json.dumps(D, sort_keys=True, indent=2)
sys.stdout.write(jstr)
