<?php
header("Content-type: application/json; charset=utf-8");
define('SRT_STATE_SUBNUMBER', 0);
define('SRT_STATE_TIME',      1);
define('SRT_STATE_TEXT',      2);
define('SRT_STATE_BLANK',     3);

$lines = file($_FILES["import_file"]["tmp_name"]);

if (pathinfo($_FILES["import_file"]["name"], PATHINFO_EXTENSION)) parseSrt($lines);

function parseSrtTime($time) {
  $times = explode(':', $time);
  return ((floatval($times[0])*3600) + (floatval($times[1])*60) + (floatval(str_replace(",", ".", $times[2]))));
}

function parseSrt($lines) {
  $subs    = array();
  $state   = SRT_STATE_SUBNUMBER;
  $subNum  = 1;
  $subText = '';
  $subTime = '';
  $endTime = 0.0;

  foreach($lines as $line) {
    $line_encoding = mb_detect_encoding($line, 'auto');
    if ($line_encoding != 'UTF-8' && $line_encoding != 'ASCII') {
      echo json_encode(array("rcode" => 1, "description" => "Text encoding (".$line_encoding.") is not UTF-8."));
      exit;
    }
    switch($state) {
        case SRT_STATE_SUBNUMBER:
            $subNum = trim($line);
            $state  = SRT_STATE_TIME;
            break;

        case SRT_STATE_TIME:
            $subTime = trim($line);
            $state   = SRT_STATE_TEXT;
            break;

        case SRT_STATE_TEXT:
            if (trim($line) == '') {
                $sub = new stdClass;
                $sub->sI = (string)$subNum;
                list($sub->b, $sub->e) = explode(' --> ', $subTime);
                $sub->b = parseSrtTime($sub->b);
                $sub->e = parseSrtTime($sub->e);
		$endTime = $sub->e;
		$sub->aT = "human";
		$sub->cM = 1;
                $sub->text   = str_replace("\n", " ", $subText);
		$sub->edited = "full";
                $subText     = '';
                $state       = SRT_STATE_SUBNUMBER;

                $subs[]      = $sub;
            } else {
                $subText .= $line;
            }
            break;
    }
  }

  if ($state != SRT_STATE_SUBNUMBER) {
    $sub = new stdClass;
    $sub->sI = (string)$subNum;
    list($sub->b, $sub->e) = explode(' --> ', $subTime);
    $sub->b = parseSrtTime($sub->b);
    $sub->e = parseSrtTime($sub->e);
    $endTime = $sub->e;
    $sub->aT = "human";
    $sub->cM = 1;
    $sub->text   = str_replace("\n", " ", $subText);
    $sub->edited = "full";
    $sTextCheck = str_replace(" ", "", $sub->text);
    if (!empty($sub->text) && !empty($sTextCheck)) $subs[] = $sub;
  }

  $dfxptar = array("rcode" => 0, "aT" => "human", "cM" => 1.0, "e" => $endTime, "s" => $subs);
  echo json_encode($dfxptar);
}

?>
