<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="author" content="MLLP">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js"></script>
    <script src="//cdn.tinymce.com/4/tinymce.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/1.5.13/clipboard.min.js"></script>
    <link href="https://fonts.googleapis.com/css?family=Lato:400,300,400italic,600,700" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=PT+Mono" rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet">
    <script src="js/tlpApi.js"></script>
    <script type="text/javascript">
    <?php 
      $request_data = null;
      if (isset($_REQUEST['request'])) $request_data = json_decode(base64_decode($_REQUEST['request']));
      echo 'var request_data = '.json_encode($request_data).';'; 
    ?>
    </script>
    <script src="js/transcription-editor.js"></script>
  </head>
  <body>
    <div id="ted-init-modal" class="modal fade" tabindex="-1" role="dialog">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h4 class="modal-title">Loading</h4>
          </div>
          <div class="modal-body">
            <p>Loading metadata...</p>
          </div>
        </div>
      </div>
    </div>
    <div class="ted-container">
      <div id="ted-editor">
        <div class="ted-editor-menu">
          <div class="btn-group">
            <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              File <span class="caret"></span>
            </button>
            <ul class="dropdown-menu">
              <li><a href="#" onclick="save_changes(); return false;"><i class="material-icons">save</i> Save changes</a></li>
              <li><a href="#" onclick="export_to(); return false;"><i class="material-icons">file_download</i> Export...</a></li>
            </ul>
          </div>
          <div class="btn-group">
            <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              Edit <span class="caret"></span>
            </button>
            <ul class="dropdown-menu">
              <li><a href="#" onclick="document.execCommand('undo'); return false;"><i class="material-icons">undo</i> Undo</a></li>
              <li><a href="#" onclick="document.execCommand('redo'); return false;"><i class="material-icons">redo</i> Redo</a></li>
              <li role="separator" class="divider"></li>
              <li><a href="#" onclick="document.execCommand('copy'); return false;"><i class="material-icons">content_copy</i> Copy</a></li>
              <li><a href="#" onclick="document.execCommand('cut'); return false;"><i class="material-icons">content_cut</i> Cut</a></li>
              <!--<li><a href="#" onclick="document.execCommand('paste'); return false;"><i class="material-icons">content_paste</i> Paste</a></li>-->
            </ul>
          </div>
          <div class="btn-group pull-right hide">
            <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              Language <span class="caret"></span>
            </button>
            <ul class="ted-language-list dropdown-menu">
            </ul>
          </div>
          <div class="btn-group">
            <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              Options <span class="caret"></span>
            </button>
            <ul class="dropdown-menu">
              <li><a href="#" onclick="jQuery('.ted-waveform-container').toggle(); return false;"><i class="material-icons">show_chart</i> Show/hide waveform</a></li>
              <li><a href="#" onclick="options['editor']['pause_on_keypress'] = !options['editor']['pause_on_keypress']; if (options['editor']['pause_on_keypress']) jQuery(this).children('i.material-icons').show(); else jQuery(this).children('i.material-icons').hide(); return false;"><i class="material-icons">check</i> Pause on key press</a></li>
            </ul>
          </div>
        </div>
        <div class="ted-editor-toolbar"></div>
        <div class="ted-editor-content" contenteditable="true"></div>
        <div class="ted-editor-toolbox"></div>
      </div>
    </div>
    <div class="ted-sidebar-right">
      <div class="ted-sidebar-draggable"></div>
      <div class="ted-media-player col-xs-12">
        <div class="ted-media-buttons text-center">
          <div id="ted-play-button" class="ted-media-button">
            <i class="material-icons">play_arrow</i> Play<br/><span class="small">(Tab)</span>
          </div>
          <div id="ted-replay5-button" class="ted-media-button">
            <i class="material-icons">replay</i> Rewind 2s<br/><span class="small">(Alt &larr;)</span>
          </div>
        </div>
        <video width="100%"></video>
      </div>
    </div>
    <div class="ted-waveform-container">
      <div class="ted-waveform-timemark-canvas"></div>
      <canvas id="ted-waveform-canvas" width="100%" height="40px"></canvas>
    </div>
  </body>
</script>
