var tlpApiUrl = 'lib/api_calls.php';

var tlpApi = {

  data: {
    id: null,
    hash: null,
    user: null,
    auth_token: null,
    expire: null
  },

  init: function(id, user, auth_token, expire, hash) {
    tlpApi.data.id = id;
    tlpApi.data.user = user;
    tlpApi.data.auth_token = auth_token;
    if (typeof expire !== 'undefined') tlpApi.data.expire = expire;
    if (typeof hash !== 'undefined') tlpApi.data.hash = hash;
  },

  speech: {
    metadata: function() {
      jQuery.ajax({
        url: tlpApiUrl+"?sub_api=speech&op=metadata&id="+tlpApi.data.id+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : ''),
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/metadata", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/metadata", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
    langs: function() {
      jQuery.ajax({
        url: tlpApiUrl+"?sub_api=speech&op=langs&id="+tlpApi.data.id+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : ''),
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/langs", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/langs", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
    get: function(lang, format, session_id) {
      var call_url = tlpApiUrl+"?sub_api=speech&op=get&id="+tlpApi.data.id+"&lang="+lang+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : '');
      if (typeof format !== 'undefined') call_url += '&format='+format;
      if (typeof session_id !== 'undefined') call_url += '&session_id='+session_id;
      jQuery.ajax({
        url: call_url,
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/get", { "detail" : { "error": false, "lang": lang, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/get", { "detail" : { "error": true, "lang": lang, "response": {} } }));
        }
      });
    },
    start_session: function(author_id, author_conf, author_name) {
      jQuery.ajax({
        url: tlpApiUrl+"?sub_api=speech&op=start_session&id="+tlpApi.data.id+"&author_id="+author_id+"&author_conf="+author_conf+(typeof author_name !== 'undefined' ? "&author_name="+author_name : "")+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : ''),
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/start_session", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/start_session", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
    end_session: function(session_id, author_id, author_conf, author_name, force, regenerate) {
      jQuery.ajax({
        url: tlpApiUrl+"?sub_api=speech&op=end_session&id="+tlpApi.data.id+"&session_id="+session_id+"&author_id="+author_id+"&author_conf="+author_conf+(typeof author_name !== 'undefined' ? "&author_name="+author_name : "")+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : ''),
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/end_session", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/end_session", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
    session_status: function(session_id, author_id, author_conf, alive) {
      jQuery.ajax({
        url: tlpApiUrl+"?sub_api=speech&op=session_status&id="+tlpApi.data.id+"&session_id="+session_id+"&author_id="+author_id+"&author_conf="+author_conf+"&alive="+alive+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : ''),
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/session_status", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/session_status", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
    mod: function(session_id, author_id, author_conf, mods, author_name) {
      var call_url = tlpApiUrl+"?sub_api=speech&op=mod&id="+tlpApi.data.id+"&session_id="+session_id+"&author_id="+author_id+"&author_conf="+author_conf+"&user="+tlpApi.data.user+"&auth_token="+tlpApi.data.auth_token+(tlpApi.data.expire != null ? '&expire='+tlpApi.data.expire : '')+(tlpApi.data.hash != null ? '&hash='+tlpApi.data.hash : '');
      if (typeof author_name !== 'undefined') call_url += '&author_name='+author_name;
      jQuery.ajax({
        method: "POST",
        url: call_url,
        data: {"mods": mods},
        dataType: "json",
        cache: false,
        success: function(response) {
          document.dispatchEvent(new CustomEvent("speech/mod", { "detail" : { "error": false, "response": (typeof response === 'object' ? response : JSON.parse(response)) } }));
        },
        error: function(e) {
          document.dispatchEvent(new CustomEvent("speech/mod", { "detail" : { "error": true, "response": {} } }));
        }
      });
    },
  }
};
