<?php
require_once("tlplib.php");

/* Globals */
$tlpApi = null;

if (isset($_GET["user"]) && isset($_GET["auth_token"])) {
  $tlpApi = new TlpApi(rawurldecode($_GET["user"]), rawurldecode($_GET["auth_token"]), (isset($_GET["expire"]) ? $_GET["expire"] : NULL));
}
else {
  http_response_code(401);
  return;
}

if (isset($_GET["sub_api"])) {
  if (strcmp($_GET["sub_api"], "speech") == 0) {
    if (isset($_GET["op"])) {
      switch ($_GET["op"]) {
        case "metadata":
          if (isset($_GET["id"])) {
            $response = $tlpApi->speech_metadata($_GET["id"], (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "langs":
          if (isset($_GET["id"])) {
            $response = $tlpApi->speech_langs($_GET["id"], (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "get":
          if (isset($_GET["id"]) && isset($_GET["lang"])) {
            $get_format = (isset($_GET["format"]) ? $_GET["format"] : NULL);
            $get_session_id = (isset($_GET["session_id"]) ? $_GET["session_id"] : NULL);
            $get_seg_filt_policy = (isset($_GET["seg_filt_policy"]) ? $_GET["seg_filt_policy"] : NULL);
            $get_sel_data_policy = (isset($_GET["sel_data_policy"]) ? $_GET["sel_data_policy"] : NULL);
            $response = $tlpApi->speech_get($_GET["id"], $_GET["lang"], $get_format, $get_session_id, $get_seg_filt_policy, $get_sel_data_policy, (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "mod":
          if (isset($_GET["id"]) && isset($_GET["session_id"]) && isset($_GET["author_id"]) && isset($_GET["author_conf"]) && isset($_POST["mods"])) {
            $mod_author_name = (isset($_GET["author_name"]) ? $_GET["author_name"] : NULL);
            if (is_array($_POST["mods"])) {
              $response = $tlpApi->speech_mod($_GET["id"], $_GET["session_id"], $_GET["author_id"], $mod_author_name, $_GET["author_conf"], $_POST["mods"], (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
              header('Content-Type: application/json');
              echo json_encode($response);  
            }
            else {
              http_response_code(400);
              return;
            }
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "start_session":
          if (isset($_GET["id"]) && isset($_GET["author_id"]) && isset($_GET["author_conf"])) {
            $start_session_author_name = (isset($_GET["author_name"]) ? $_GET["author_name"] : NULL);
            $response = $tlpApi->speech_start_session($_GET["id"], $_GET["author_id"], $start_session_author_name, $_GET["author_conf"], "transcriber", (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "session_status":
          if (isset($_GET["id"]) && isset($_GET["session_id"]) && isset($_GET["author_id"]) && isset($_GET["author_conf"])) {
            $session_status_author_name = (isset($_GET["author_name"]) ? $_GET["author_name"] : NULL);
            $response = $tlpApi->speech_session_status($_GET["id"], $_GET["session_id"], $_GET["author_id"], $session_status_author_name, $_GET["author_conf"], (isset($_GET["alive"]) ? intval($_GET["alive"]) : 1), (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "end_session":
          if (isset($_GET["id"]) && isset($_GET["session_id"]) && isset($_GET["author_id"]) && isset($_GET["author_conf"])) {
            $end_session_force = (isset($_GET["force"]) ? intval($_GET["force"]) : 0);
            $end_session_regenerate = (isset($_GET["regenerate"]) ? intval($_GET["regenerate"]) : 0);
            $response = $tlpApi->speech_end_session($_GET["id"], $_GET["session_id"], $_GET["author_id"], $session_status_author_name, $_GET["author_conf"], $end_session_force, $end_session_regenerate, (isset($_GET["hash"]) ? $_GET["hash"] : NULL));
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        case "status":
          if (isset($_GET["upload_id"])) {
            $response = $tlpApi->speech_status($_GET["upload_id"]);
            header('Content-Type: application/json');
            echo json_encode($response);
          }
          else {
            http_response_code(400);
            return;
          }
          break;
        default:
          http_response_code(404);
          return;
      }
    }
  }
  else {
    http_response_code(400);
    return;
  }
}
else {
  http_response_code(400);
  return;
}
?>
